﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Proteus
{
    public class MakeManager
    {
        ProjectTreeManager _objBuildTreeManager = new ProjectTreeManager();
        ProjectsFile _objProjectsFile;
        public MakeManager()
        {
        }
        public void LoadBuildTargets(ProjectsFile objProjectsFile)
        {
            _objProjectsFile = objProjectsFile;
            _objBuildTreeManager.BuildProjectDependencyTree(_objProjectsFile.Targets);
        }
        public void Make()
        {
            string makeFileOutputPath = _objProjectsFile.GetBuildConfig().GetMakeFilePath();
            string depFileOutputPath = _objProjectsFile.GetBuildConfig().GetBatchFilePath();

            BuildOrganizer bo = new BuildOrganizer(makeFileOutputPath, depFileOutputPath, _objProjectsFile.GetBuildConfig());

            ProjectTree objTree = _objBuildTreeManager.GetTreeByConfiguration(_objProjectsFile.GetBuildConfig().GlobalBuildConfiguration);
            
            if (objTree == null)
                throw new Exception("Build tree could not be found for build configuration " + 
                    _objProjectsFile.GetBuildConfig().GlobalBuildConfiguration.ConfigurationName + 
                    " - " + _objProjectsFile.GetBuildConfig().GlobalBuildConfiguration.BuildPlatform);

            //instead send the tree in here.
            bo.BuildMakeFilesFromTargets(objTree);
            bo.WriteMakeFiles();

            //TEST
            // bo.LoadFilesAndCreateHierarchy();
        }

    }
}
