﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Proteus
{
    public class ProcessUtils
    {



        public static System.Diagnostics.Process StartProcessSafe(string strPath, bool blnWaitForStart = true, ulong intMaxWaitTimeMilliseconds = 2000)
        {
            System.Diagnostics.Process objProcess;
            objProcess = new System.Diagnostics.Process();
            objProcess.StartInfo.FileName = strPath; //not the full application path
            objProcess.Start();

            // Wait for process to start
            if(blnWaitForStart)
            {
                ulong tA = Win32Utils.GetTickCount64();
                ulong tB = Win32Utils.GetTickCount64();
                while ((tB - tA < intMaxWaitTimeMilliseconds) && !objProcess.HasExited) 
                {
                    System.Diagnostics.Process process = null;
                    tB = Win32Utils.GetTickCount64();
                    try
                    {
                         process = System.Diagnostics.Process.GetProcessById(objProcess.Id);
                    }
                    catch(Exception ex)
                    {
                        //Continue catching exception until process is available
                    }

                    if (process != null)
                        break;

                    System.Windows.Forms.Application.DoEvents();
                }
            }
            return objProcess;
        }
    }
}
