﻿/*
 * Romulus Makefile System
 * 
 *  Derek Page
 *  20150701
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Proteus;
using Spartan;
namespace Romulus
{
    public class Program
    {
        public static string strPlatform;
        public static string strConfig;
        public static int intErrorLimit;
        public static bool blnAttatchedToUi;
        public static string strProjectFile;
        static void Main(string[] args)
        {
            Proteus.Proteus.Initialize("romulus.log");
            Globals.Logger.LogInfo("Initializing..");
            RomulusCommandLineArgs rargs = new RomulusCommandLineArgs();
            rargs.ParseArgs(args.ToList());
           // BuildConfig.LoadConfig();

            try
            {
                if (String.IsNullOrEmpty(rargs.PlatformName)|| String.IsNullOrEmpty(rargs.ConfigName))
                    throw new Exception("Build platform or configuration was not specified. Makefile cannot generate wihout a configuration which matches at least one project configuration. Specify these with /cn\"..\" /cp\"..\" switches.");

                ProjectsFile pf = BuildUtils.LoadProjectsFile(rargs);

                MakeManager mm = new MakeManager();
                mm.LoadBuildTargets(pf);
                mm.Make();
            }
            catch (Exception ex)
            {
                Globals.Logger.LogError(ex.ToString());
                System.Diagnostics.Debugger.Break();
            }

            Globals.Logger.LogInfo("Romulus makefile generation complete.");
        }



    }
}
