﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Proteus;
using System.Xml;

namespace Spartan
{
    public class BuildUtils
    {
        public const string DefaultTargetName = "*default";

        public static ProjectsFile LoadProjectsFile(RomulusCommandLineArgs args)
        {
            ProjectsFile objProjectsFile;
            Globals.Logger.LogInfo("Loading projects..");

            //Project doens't exist
            if (!System.IO.File.Exists(args.ProjectFilePath))
                return null;

            string strExt = System.IO.Path.GetExtension(args.ProjectFilePath);

            if (strExt.ToLower().Equals(".sln"))
            {
                //create temporary projects file
                // write to file.
                // set the temporary file in the args.
                string strFile = ParseVisualStudioSolutionToTempDirectory(args.ProjectFilePath);
                args.ProjectFilePath = strFile;
            }

            objProjectsFile = new ProjectsFile();
            objProjectsFile.Load(args);

            return objProjectsFile;
        }

        public static string ParseVisualStudioSolutionToTempDirectory(string solutionFilePath)
        {
            //20151120 - stopping this nonsense.  Yeah this is possible but it woudl take a week to implement right.
            throw new Exception("Failure. Visual studio solution parsing is only half implemented.  Must finish.");

            string strRetFile = "rbproj_";
            strRetFile += Win32Utils.GetTickCount64().ToString();
            strRetFile += ".rbproj";
            // Parse
            //Sprache.Parser< JetBrains.Application.SinceClr4.BuildScript.Compile.SolutionFileParser.SolutionNode> xx = 
            //    JetBrains.Application.SinceClr4.BuildScript.Compile.SolutionFileParser.Parser.Solution;
            //;

            //Get the project files.'
            //doesn't give extra info..no files or anything.  no point really.
            //VSSolution solution = new VSSolution(solutionFilePath);
       /*
       ANALYSIS OF VCXPROJ FILE

            Project Condition Items << parse these based on the project name.
                ItemGroup
                PropertyGroup
                ImportGroup
                ItemDefinitionGroup
            ItemGroup
                ClCompile Include="" - include ALL of these where the extension is .cpp
            ItemGroup Label = "ProjectConfigurations"
            PropertyGroup
                WindowsTargetPlatformVersion> 8.1 < ----- manually specify this.

    */
            MsvcSolution ms = new MsvcSolution(solutionFilePath);
            string solutionDir = System.IO.Path.GetDirectoryName(solutionFilePath);
            foreach (MsvcProject proj in ms.Projects)
            {
                string fullProjectPath = System.IO.Path.Combine(solutionDir, proj.RelativePath);

                XmlDocument doc = new XmlDocument();
                doc.Load(fullProjectPath);
                XmlNodeList list = doc.GetElementsByTagName("PropertyGroup");
                foreach(XmlNode n in list)
                {
                  //  n.att
                }
                //foreach()
                // Read the project files.
                //using (XmlReader reader = XmlReader.Create(new System.IO.StringReader(fullProjectPath)))
                //{
                //    while (reader.Read())
                //    {
                //        int n = 0;
                //        n++;
                //    }
                //}

            }
            return strRetFile;
        }
        public static string[] SplitValues(string str, char ch)
        {
            string[] ret;

            int idx = str.IndexOf(ch);
            if (idx < 0)
            {
                ret = new string[1];
                ret[0] = str;
            }
            else
            {
                ret = new string[2];
                ret[0] = str.Substring(0, idx);
                ret[1] = str.Substring(idx + 1, str.Length - (idx + 1));
            }

            return ret;
        }
        public static string Enquote(string a)
        {
            return StringUtils.Enquote(a);
        }
        public static string Dequote(string a)
        {
            return StringUtils.Dequote(a);
        }
        public static string ParseEatComment(string x, string comment = "#")
        {
            if (!x.Contains(comment))
                return x;
            int ind = x.IndexOf(comment);
            string ret = x.Substring(0, ind);
            return ret.Trim();
        }

    }
}
