﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Proteus;
namespace Spartan
{
    public class MakeManager
    {
        ProjectTreeManager _objBuildTreeManager = new ProjectTreeManager();
        ProjectsFile _objProjectsFile;
        public MakeManager()
        {
        }
        public void LoadBuildTargets(ProjectsFile objProjectsFile)
        {
            _objProjectsFile = objProjectsFile;
            _objBuildTreeManager.BuildProjectDependencyTree(_objProjectsFile.Targets);
        }
        public void Make()
        {
            BuildOrganizer bo = new BuildOrganizer(_objProjectsFile.GetBuildConfig());

            ProjectTree objTree = _objBuildTreeManager.GetTreeByConfiguration(_objProjectsFile.GetBuildConfig().GlobalBuildConfiguration);
            
            if (objTree == null)
                throw new Exception("Build tree could not be found for build configuration '" + 
                    _objProjectsFile.GetBuildConfig().GlobalBuildConfiguration.ConfigurationName + 
                    " - " + _objProjectsFile.GetBuildConfig().GlobalBuildConfiguration.BuildPlatform 
                    + "'. This probably indicates that the build configuration in the .rbproj project file does " + 
                    " not match the build configuration set in the GUI window (or the " 
                    + BuildFlags.ConfigPlatform + " " + BuildFlags.ConfigName + " switches passed to the program).");

            //instead send the tree in here.
            bo.BuildMakeFilesFromTargets(objTree);
            bo.WriteMakeFiles();

            //TEST
            // bo.LoadFilesAndCreateHierarchy();
        }

    }
}
